defmodule DecentralisedBookIndex.Sync.ApiClients.FetchJsonsTest do
  use DecentralisedBookIndex.DataCase

  alias DecentralisedBookIndex.Sync.ApiClients.FetchJsons
  alias DecentralisedBookIndex.Metadata

  alias DecentralisedBookIndex.TestEndpoints

  @test_server_endpoint TestEndpoints.test_api_endpoint()

  describe "authors api" do
    test "get authors" do
      for number <- 1..11 do
        Metadata.create_author!("Author#{number}", "An description#{number}")
      end

      assert {:ok, records} = FetchJsons.get("#{@test_server_endpoint}/api/v1/json/author")
      assert length(records) == 11
    end
  end
end
